#include <stdio.h>
#include <unistd.h>
#include <string.h>

#include <stdlib.h>
#include <net/if.h>
#include <sys/ioctl.h>
#include <sys/socket.h>
#include <linux/can.h>
#include <linux/can/raw.h>

#include <wiringSerial.h>
#include <wiringPi.h>
#include <strings.h> 
#include <sys/time.h>

//CAN
#define CAN_ID 0x123                //CAN ID
#define CAN_Data_Len 8              //CAN Len
//RS485
#define EN_485 4
#define Baudrate 115200             //RS485 Baudrate

int Number_Received=0;
//CAN
int s;
struct can_frame frame;
//RS485
int fd;

int CAN_INIT(void)
{
    int ret;
    struct sockaddr_can addr;
    struct ifreq ifr;
    memset(&frame, 0, sizeof(struct can_frame));

    system("sudo ip link set can0 type can bitrate 250000");
    system("sudo ifconfig can0 up");
    printf("this is a can send demo\r\n");
        
    //1.Create socket
    s = socket(PF_CAN, SOCK_RAW, CAN_RAW);
    if (s < 0) {
        perror("socket PF_CAN failed");
        return 1;
    }
    
    //2.Specify can0 device
    strcpy(ifr.ifr_name, "can0");
    ret = ioctl(s, SIOCGIFINDEX, &ifr);
    if (ret < 0) {
        perror("ioctl failed");
        return 1;
    }
    
    //3.Bind the socket to can0
    addr.can_family = AF_CAN;
    addr.can_ifindex = ifr.ifr_ifindex;
    ret = bind(s, (struct sockaddr *)&addr, sizeof(addr));
    if (ret < 0) {
        perror("bind failed");
        return 1;
    }
    
    //4.Disable filtering rules, do not receive packets, only send
    setsockopt(s, SOL_CAN_RAW, CAN_RAW_FILTER, NULL, 0);

   
    return 0;
}
void CAN_Send(void)
{
    int  nbytes;
    //5.Set send data
    frame.can_id = CAN_ID;
    frame.can_dlc = CAN_Data_Len;
    frame.data[0] = 0x01;
    frame.data[1] = 0x02;
    frame.data[2] = 0x03;
    frame.data[3] = 0x04;
    frame.data[4] = 0x05;
    frame.data[5] = 0x06;
    frame.data[6] = 0x07;
    frame.data[7] = 0x08;
    
    printf("can_id  = 0x%X\r\n", frame.can_id);
    printf("can_dlc = %d\r\n", frame.can_dlc);
    
    int i = 0;
    for(i = 0; i < CAN_Data_Len; i++)
        printf("CAN Send data[%d] = 0x%02X\r\n", i, frame.data[i]);
    printf("\r\n");
    //6.Send message
    nbytes = write(s, &frame, sizeof(frame)); 
    if(nbytes != sizeof(frame)) {
        printf("Send Error frame[0]!\r\n");
        system("sudo ifconfig can0 down");
    }
    Number_Received++;
}
int RS485_INIT(void)
{

    if(wiringPiSetupGpio() < 0) { //use BCM2835 Pin number table
        printf("set wiringPi lib failed	!!! \r\n");
        return 1;
    } else {
        printf("set wiringPi lib success  !!! \r\n");
    }
    pinMode(EN_485, OUTPUT);
    digitalWrite(EN_485,LOW);

    if((fd = serialOpen ("/dev/ttyS0",Baudrate)) < 0) {
        printf("serial err\n");
        return -1;
    }
    serialFlush(fd);
    
    return 0;
}
int RS485_Read(void)
{
    int nbytes;
    nbytes = serialDataAvail (fd);
    if(nbytes == -1) {
        printf("receive data error\r\n");
        return -1;
    }else if(nbytes>0){
        printf("RS485 Read Data : 0x%02X\r\n", serialGetchar(fd));
        //data = serialGetchar(fd) - 48;
        // printf("%c\r\n", serialGetchar(fd));
    }
    return 0;

}


int main()
{
    int x,y;
    if(CAN_INIT() == 0 && RS485_INIT() == 0)
    { 
        while(1)
        {
            for(x = 0;x < 10001;x++)
            {
                if(x == 10000)
                {
                    y++;
                    if(y==1)
                    {
                        printf("======================== NEW Data %d =========================\r\n",Number_Received);
                        printf("Count Down :");
                        fflush(stdout);         // Refresh the buffer to ensure that data is sent in real time
                    }
                    if(y%20 == 0){
                        printf("%d ", 6 - y/20);
                        fflush(stdout);         // Refresh the buffer to ensure that data is sent in real time
                    }
                    if(y==100)
                    {
                        y=0;
                        printf("\r\n");
                        CAN_Send();
                    }
                }  
                RS485_Read(); 
            }
        }
    }
    else
        printf("INIT err");
    return 0;

}

